import func from '../../utils/FunctionSet'

const state = {
    hasConnectCount:0,
    pressureData:[],
    blueToothDevice:'',
    deviceStatus:'',
    blueSendData:'',
    blueDeviceList: [],
    scanLoading:false,
    blueDeviceConnectStatus:-1,  //蓝牙连接状态  1 成功 0失败 -1初始值
    blueDeviceDisConnectStatus:-1,  //蓝牙断开状态  1 成功 0失败 -1初始值
    characteristicServiceList:[],

}

const actions = {
    resetBlueDeviceList({commit}) {
        commit('resetBlueDeviceList')
    },
    resetConnectBlueStatus({commit}) {
        commit('resetConnectBlueStatus')
    },
    resetDisConnectBlueStatus({commit}){
        commit('resetDisConnectBlueStatus')
    },
    resetCharacteristicServiceList({commit}){
        commit('resetDisConnectBlueStatus')
    },
    resetCharacteristicServerList({commit}) {
        commit('resetCharacteristicServerList')
    },
    resetBlueToothData({commit}) {
        commit('resetBlueToothData')
    }

}
const mutations = {
    SOCKET_reconTest: (state, status) => {
        console.log(status)
    },
    SOCKET_connectCount: (state, count) => {
        //console.log(count)
        state.hasConnectCount = count
    },
    // 断开一个客户端
    SOCKET_disConnectOneClient:(state) =>{
         state.hasConnectCount--
    },
    SOCKET_pressureData(state,data) {
        state.pressureData = data
    },
    SOCKET_connectedClient(state,data) {
        console.log(data)
    },
    SOCKET_setBlueToothDevice(state,data) {
        state.blueToothDevice = data
    },
    SOCKET_setDeviceStatus(state,data) {
        state.deviceStatus = data
    },
    SOCKET_sendBlueData(state,data) {
        state.blueSendData = func.buf2hex(data)
    },
    SOCKET_blueDeviceList(state, resp) {
        state.scanLoading = false
        if (resp.ok) {
            state.blueDeviceList = resp.data;
        } else {
            console.log(resp)
        }
    },
    // 连接蓝牙设备返回
    SOCKET_connectDeviceBack(state, resp) {
        if (resp.ok) {
            state.blueDeviceConnectStatus = 1
        } else {
            state.blueDeviceConnectStatus = 0
        }
    },
    // 断开蓝牙设备返回
    SOCKET_disConnectDeviceBack(state, resp) {
        if (resp.ok) {
            state.blueDeviceDisConnectStatus = 1
        } else {
            state.blueDeviceDisConnectStatus = 0
        }
    },
    SOCKET_pushCharacteristicServerList(state,info) {
        state.characteristicServiceList.push(info)
    },
    resetBlueDeviceList(state) {
        state.blueDeviceList = []
        state.scanLoading = true
    },
    // 重置蓝牙连接转态 （蓝牙服务页面返回蓝牙index 页面调用）
    resetConnectBlueStatus(state) {
        state.blueDeviceConnectStatus = -1
    },
    // 重置断开蓝牙连接转态 （蓝牙index页面加载时调用
    resetDisConnectBlueStatus(state) {
        state.blueDeviceDisConnectStatus = -1
    },
    // 重置characteristicServerList
    resetCharacteristicServerList(state) {
        state.characteristicServiceList = []
    },
    resetBlueToothData(state) {
        state.blueToothData = ''
    }
}

const getters = {
    blueDeviceConnectStatus:state=>state.blueDeviceConnectStatus,
    blueDeviceDisConnectStatus:state=>state.blueDeviceDisConnectStatus,
    hasConnectCount:state=>state.hasConnectCount,
    pressureData:state=>state.pressureData,
    blueToothDevice:state=>state.blueToothDevice,
    deviceStatus:state=>state.deviceStatus,
    blueSendData:state=>state.blueSendData,
    scanLoading:state=>state.scanLoading,
    blueDeviceList:state=>state.blueDeviceList,
    characteristicServiceList:state=>state.characteristicServiceList,
}


    export default {
    state,
    actions,
    mutations,
    getters,
    }
